(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global['redux-actions-generator'] = factory());
}(this, (function () { 'use strict';

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      var ownKeys = Object.keys(source);

      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    }

    return target;
  }

  /**
   * @function toUpperCase
   * @param  {string} str
   * @return {string} {uppercase sting}
   */
  var toUpperCase = function toUpperCase() {
    var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
    return str.toUpperCase();
  };
  /**
   * @function reduceActions
   * @param  {string} prefix {A prefix to put before each one of the actions}
   * @return {funvtion} {a function that returns the action object plus the next generate action}
   */


  var reduceActions = function reduceActions(prefix) {
    return function (actions, key) {
      return _objectSpread({}, actions, _defineProperty({}, key, "".concat(prefix, "/").concat(key)));
    };
  };
  /**
   * @function createActions
   * @param  {string} prefix {A prefix to put before each one of the actions}
   * @param  {Array<string>} keys = []   {array of actions string}
   * @return {object} {The final actions object}
   */


  var createActions = function createActions() {
    var prefix = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
    var keys = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    return keys.map(toUpperCase).reduce(reduceActions(prefix), {});
  };

  return createActions;

})));
